diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/stats/wifi-example-sim.cc ns-3.38/examples/stats/wifi-example-sim.cc
--- ns-3.37/examples/stats/wifi-example-sim.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/stats/wifi-example-sim.cc	2023-03-16 20:54:23.568868400 -0700
@@ -36,7 +36,7 @@
 #include "ns3/mobility-module.h"
 #include "ns3/network-module.h"
 #include "ns3/stats-module.h"
-#include "ns3/yans-wifi-helper.h"
+#include "ns3/wifi-module.h"
 
 #include <ctime>
 #include <sstream>
@@ -49,20 +49,16 @@
  * Function called when a packet is transmitted.
  *
  * \param datac The counter of the number of transmitted packets.
- * \param path The callback context
- * \param packet The transmsiotted packet.
+ * \param path The callback context.
+ * \param packet The transmitted packet.
  */
 void
 TxCallback(Ptr<CounterCalculator<uint32_t>> datac, std::string path, Ptr<const Packet> packet)
 {
     NS_LOG_INFO("Sent frame counted in " << datac->GetKey());
     datac->Update();
-    // end TxCallback
 }
 
-//----------------------------------------------------------------------
-//-- main
-//----------------------------------------------
 int
 main(int argc, char* argv[])
 {
@@ -109,7 +105,7 @@
         input = sstr.str();
     }
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Create nodes and network stacks
     //--------------------------------------------
     NS_LOG_INFO("Creating nodes.");
@@ -131,7 +127,7 @@
     ipAddrs.SetBase("192.168.0.0", "255.255.255.0");
     ipAddrs.Assign(nodeDevices);
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Setup physical layout
     //--------------------------------------------
     NS_LOG_INFO("Installing static mobility; distance " << distance << " .");
@@ -142,7 +138,7 @@
     mobility.SetPositionAllocator(positionAlloc);
     mobility.Install(nodes);
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Create a custom traffic source and sink
     //--------------------------------------------
     NS_LOG_INFO("Create traffic source & sink.");
@@ -159,7 +155,7 @@
     Config::Set("/NodeList/*/ApplicationList/*/$Sender/Destination",
                 Ipv4AddressValue("192.168.0.2"));
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Setup stats and data collection
     //--------------------------------------------
 
@@ -212,23 +208,24 @@
     receiver->SetCounter(appRx);
     data.AddDataCalculator(appRx);
 
-    /**
-     * Just to show this is here...
-     Ptr<MinMaxAvgTotalCalculator<uint32_t> > test =
-     CreateObject<MinMaxAvgTotalCalculator<uint32_t> >();
-     test->SetKey("test-dc");
-     data.AddDataCalculator(test);
-
-     test->Update(4);
-     test->Update(8);
-     test->Update(24);
-     test->Update(12);
-    **/
+    // Just to show this is here...
+
+    /*
+    Ptr<MinMaxAvgTotalCalculator<uint32_t>> test =
+        CreateObject<MinMaxAvgTotalCalculator<uint32_t>>();
+    test->SetKey("test-dc");
+    data.AddDataCalculator(test);
+
+    test->Update(4);
+    test->Update(8);
+    test->Update(24);
+    test->Update(12);
+    */
 
     // This DataCalculator connects directly to the transmit trace
     // provided by our Sender Application.  It records some basic
     // statistics about the sizes of the packets received (min, max,
-    // avg, total # bytes), although in this scenaro they're fixed.
+    // avg, total # bytes), although in this scenario they're fixed.
     Ptr<PacketSizeMinMaxAvgTotalCalculator> appTxPkts =
         CreateObject<PacketSizeMinMaxAvgTotalCalculator>();
     appTxPkts->SetKey("tx-pkt-size");
@@ -247,13 +244,13 @@
     receiver->SetDelayTracker(delayStat);
     data.AddDataCalculator(delayStat);
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Run the simulation
     //--------------------------------------------
     NS_LOG_INFO("Run Simulation.");
     Simulator::Run();
 
-    //------------------------------------------------------------
+    //--------------------------------------------
     //-- Generate statistics output.
     //--------------------------------------------
 
@@ -286,6 +283,5 @@
     // Free any memory here at the end of this example.
     Simulator::Destroy();
 
-    // end main
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tcp/tcp-linux-reno.cc ns-3.38/examples/tcp/tcp-linux-reno.cc
--- ns-3.37/examples/tcp/tcp-linux-reno.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/tcp/tcp-linux-reno.cc	2023-03-16 20:54:23.568868400 -0700
@@ -152,21 +152,11 @@
     // Set recovery algorithm and TCP variant
     Config::SetDefault("ns3::TcpL4Protocol::RecoveryType",
                        TypeIdValue(TypeId::LookupByName(recovery)));
-    if (tcpTypeId == "ns3::TcpWestwoodPlus")
-    {
-        // TcpWestwoodPlus is not an actual TypeId name; we need TcpWestwood here
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType", TypeIdValue(TcpWestwood::GetTypeId()));
-        // the default protocol type in ns3::TcpWestwood is WESTWOOD
-        Config::SetDefault("ns3::TcpWestwood::ProtocolType", EnumValue(TcpWestwood::WESTWOODPLUS));
-    }
-    else
-    {
-        TypeId tcpTid;
-        NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(tcpTypeId, &tcpTid),
-                            "TypeId " << tcpTypeId << " not found");
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType",
-                           TypeIdValue(TypeId::LookupByName(tcpTypeId)));
-    }
+    TypeId tcpTid;
+    NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(tcpTypeId, &tcpTid),
+                        "TypeId " << tcpTypeId << " not found");
+    Config::SetDefault("ns3::TcpL4Protocol::SocketType",
+                       TypeIdValue(TypeId::LookupByName(tcpTypeId)));
 
     // Create nodes
     NodeContainer leftNodes;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tcp/tcp-star-server.cc ns-3.38/examples/tcp/tcp-star-server.cc
--- ns-3.37/examples/tcp/tcp-star-server.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/tcp/tcp-star-server.cc	2023-03-16 20:54:23.568868400 -0700
@@ -36,7 +36,7 @@
 //       ./ns3 run "tcp-star-server --ns3::OnOffApplication::DataRate=10000"
 //       ./ns3 run "tcp-star-server --ns3::OnOffApplication::PacketSize=500"
 // See the ns-3 tutorial for more info on the command line:
-// http://www.nsnam.org/tutorials.html
+// https://www.nsnam.org/docs/tutorial/html/index.html
 
 #include "ns3/applications-module.h"
 #include "ns3/core-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tcp/tcp-validation.cc ns-3.38/examples/tcp/tcp-validation.cc
--- ns-3.37/examples/tcp/tcp-validation.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/tcp/tcp-validation.cc	2023-03-16 20:54:23.568868400 -0700
@@ -34,7 +34,7 @@
 
 // This program is designed to observe long-running TCP congestion control
 // behavior over a configurable bottleneck link.  The program is also
-// instrumented to check progam data against validated results, when
+// instrumented to check program data against validated results, when
 // the validation option is enabled.
 //
 // ---> downstream (primary data transfer from servers to clients)
@@ -181,7 +181,7 @@
 {
     // TCP segment size is configured below to be 1448 bytes
     // so that we can report cwnd in units of segments
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << static_cast<double>(newCwnd) / 1448
                   << std::endl;
@@ -225,7 +225,7 @@
 void
 TraceFirstDctcp(std::ofstream* ofStream, uint32_t bytesMarked, uint32_t bytesAcked, double alpha)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << alpha << std::endl;
     }
@@ -277,7 +277,7 @@
 void
 TraceFirstRtt(std::ofstream* ofStream, Time oldRtt, Time newRtt)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << newRtt.GetSeconds() * 1000
                   << std::endl;
@@ -296,7 +296,7 @@
 {
     // TCP segment size is configured below to be 1448 bytes
     // so that we can report cwnd in units of segments
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << static_cast<double>(newCwnd) / 1448
                   << std::endl;
@@ -313,7 +313,7 @@
 void
 TraceSecondRtt(std::ofstream* ofStream, Time oldRtt, Time newRtt)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << newRtt.GetSeconds() * 1000
                   << std::endl;
@@ -331,7 +331,7 @@
 void
 TraceSecondDctcp(std::ofstream* ofStream, uint32_t bytesMarked, uint32_t bytesAcked, double alpha)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << alpha << std::endl;
     }
@@ -344,9 +344,9 @@
  * \param rtt RTT value.
  */
 void
-TracePingRtt(std::ofstream* ofStream, Time rtt)
+TracePingRtt(std::ofstream* ofStream, uint16_t, Time rtt)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << rtt.GetSeconds() * 1000 << std::endl;
     }
@@ -385,7 +385,7 @@
 void
 TraceQueueDrop(std::ofstream* ofStream, Ptr<const QueueDiscItem> item)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << std::hex << item->Hash() << std::endl;
     }
@@ -402,7 +402,7 @@
 void
 TraceQueueMark(std::ofstream* ofStream, Ptr<const QueueDiscItem> item, const char* reason)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << std::hex << item->Hash() << std::endl;
     }
@@ -421,7 +421,7 @@
 TraceQueueLength(std::ofstream* ofStream, DataRate queueLinkRate, uint32_t oldVal, uint32_t newVal)
 {
     // output in units of ms
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << std::fixed
                   << static_cast<double>(newVal * 8) / (queueLinkRate.GetBitRate() / 1000)
@@ -438,7 +438,7 @@
 void
 TraceMarksFrequency(std::ofstream* ofStream, Time marksSamplingInterval)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << g_marksObserved << std::endl;
     }
@@ -459,7 +459,7 @@
 TraceFirstThroughput(std::ofstream* ofStream, Time throughputInterval)
 {
     double throughput = g_firstBytesReceived * 8 / throughputInterval.GetSeconds() / 1e6;
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " " << throughput << std::endl;
     }
@@ -508,7 +508,7 @@
 void
 TraceSecondThroughput(std::ofstream* ofStream, Time throughputInterval)
 {
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         *ofStream << Simulator::Now().GetSeconds() << " "
                   << g_secondBytesReceived * 8 / throughputInterval.GetSeconds() / 1e6 << std::endl;
@@ -681,7 +681,7 @@
     cmd.Parse(argc, argv);
 
     // If validation is selected, perform some configuration checks
-    if (g_validate != "")
+    if (!g_validate.empty())
     {
         NS_ABORT_MSG_UNLESS(g_validate == "dctcp-10ms" || g_validate == "dctcp-80ms" ||
                                 g_validate == "cubic-50ms-no-ecn" || g_validate == "cubic-50ms-ecn",
@@ -689,7 +689,7 @@
         if (g_validate == "dctcp-10ms" || g_validate == "dctcp-80ms")
         {
             NS_ABORT_MSG_UNLESS(firstTcpType == "dctcp", "Incorrect TCP");
-            NS_ABORT_MSG_UNLESS(secondTcpType == "", "Incorrect TCP");
+            NS_ABORT_MSG_UNLESS(secondTcpType.empty(), "Incorrect TCP");
             NS_ABORT_MSG_UNLESS(linkRate == DataRate("50Mbps"), "Incorrect data rate");
             NS_ABORT_MSG_UNLESS(queueUseEcn == true, "Incorrect ECN configuration");
             NS_ABORT_MSG_UNLESS(stopTime >= Seconds(15), "Incorrect stopTime");
@@ -705,7 +705,7 @@
         else if (g_validate == "cubic-50ms-no-ecn" || g_validate == "cubic-50ms-ecn")
         {
             NS_ABORT_MSG_UNLESS(firstTcpType == "cubic", "Incorrect TCP");
-            NS_ABORT_MSG_UNLESS(secondTcpType == "", "Incorrect TCP");
+            NS_ABORT_MSG_UNLESS(secondTcpType.empty(), "Incorrect TCP");
             NS_ABORT_MSG_UNLESS(baseRtt == MilliSeconds(50), "Incorrect RTT");
             NS_ABORT_MSG_UNLESS(linkRate == DataRate("50Mbps"), "Incorrect data rate");
             NS_ABORT_MSG_UNLESS(stopTime >= Seconds(20), "Incorrect stopTime");
@@ -771,7 +771,7 @@
         enableSecondTcp = true;
         secondTcpTypeId = TcpDctcp::GetTypeId();
     }
-    else if (secondTcpType == "")
+    else if (secondTcpType.empty())
     {
         enableSecondTcp = false;
         NS_LOG_DEBUG("No second TCP selected");
@@ -841,7 +841,7 @@
     std::ofstream queueMarkOfStream;
     std::ofstream queueMarksFrequencyOfStream;
     std::ofstream queueLengthOfStream;
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         pingOfStream.open(pingTraceFile, std::ofstream::out);
         firstTcpRttOfStream.open(firstTcpRttTraceFile, std::ofstream::out);
@@ -975,12 +975,13 @@
     ////////////////////////////////////////////////////////////
     // application setup                                      //
     ////////////////////////////////////////////////////////////
-    V4PingHelper pingHelper("192.168.1.2");
+    PingHelper pingHelper(Ipv4Address("192.168.1.2"));
     pingHelper.SetAttribute("Interval", TimeValue(pingInterval));
     pingHelper.SetAttribute("Size", UintegerValue(pingSize));
+    pingHelper.SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::SILENT));
     ApplicationContainer pingContainer = pingHelper.Install(pingServer);
-    Ptr<V4Ping> v4Ping = pingContainer.Get(0)->GetObject<V4Ping>();
-    v4Ping->TraceConnectWithoutContext("Rtt", MakeBoundCallback(&TracePingRtt, &pingOfStream));
+    Ptr<Ping> ping = pingContainer.Get(0)->GetObject<Ping>();
+    ping->TraceConnectWithoutContext("Rtt", MakeBoundCallback(&TracePingRtt, &pingOfStream));
     pingContainer.Start(Seconds(1));
     pingContainer.Stop(stopTime - Seconds(1));
 
@@ -1088,7 +1089,7 @@
     Simulator::Run();
     Simulator::Destroy();
 
-    if (g_validate == "")
+    if (g_validate.empty())
     {
         pingOfStream.close();
         firstTcpCwndOfStream.close();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tcp/tcp-variants-comparison.cc ns-3.38/examples/tcp/tcp-variants-comparison.cc
--- ns-3.37/examples/tcp/tcp-variants-comparison.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/tcp/tcp-variants-comparison.cc	2023-03-16 20:54:23.568868400 -0700
@@ -59,14 +59,14 @@
 static std::map<uint32_t, bool> firstSshThr;                    //!< First SlowStart threshold.
 static std::map<uint32_t, bool> firstRtt;                       //!< First RTT.
 static std::map<uint32_t, bool> firstRto;                       //!< First RTO.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> cWndStream; //!< Congstion window outut stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> cWndStream; //!< Congstion window output stream.
 static std::map<uint32_t, Ptr<OutputStreamWrapper>>
-    ssThreshStream; //!< SlowStart threshold outut stream.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> rttStream;      //!< RTT outut stream.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> rtoStream;      //!< RTO outut stream.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextTxStream;   //!< Next TX outut stream.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextRxStream;   //!< Next RX outut stream.
-static std::map<uint32_t, Ptr<OutputStreamWrapper>> inFlightStream; //!< In flight outut stream.
+    ssThreshStream; //!< SlowStart threshold output stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> rttStream;      //!< RTT output stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> rtoStream;      //!< RTO output stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextTxStream;   //!< Next TX output stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> nextRxStream;   //!< Next RX output stream.
+static std::map<uint32_t, Ptr<OutputStreamWrapper>> inFlightStream; //!< In flight output stream.
 static std::map<uint32_t, uint32_t> cWndValue;                      //!< congestion window value.
 static std::map<uint32_t, uint32_t> ssThreshValue;                  //!< SlowStart threshold value.
 
@@ -342,7 +342,7 @@
 int
 main(int argc, char* argv[])
 {
-    std::string transport_prot = "TcpWestwood";
+    std::string transport_prot = "TcpWestwoodPlus";
     double error_p = 0.0;
     std::string bandwidth = "2Mbps";
     std::string delay = "0.01ms";
@@ -365,7 +365,7 @@
     cmd.AddValue("transport_prot",
                  "Transport protocol to use: TcpNewReno, TcpLinuxReno, "
                  "TcpHybla, TcpHighSpeed, TcpHtcp, TcpVegas, TcpScalable, TcpVeno, "
-                 "TcpBic, TcpYeah, TcpIllinois, TcpWestwood, TcpWestwoodPlus, TcpLedbat, "
+                 "TcpBic, TcpYeah, TcpIllinois, TcpWestwoodPlus, TcpLedbat, "
                  "TcpLp, TcpDctcp, TcpCubic, TcpBbr",
                  transport_prot);
     cmd.AddValue("error_p", "Packet error rate", error_p);
@@ -423,21 +423,11 @@
     Config::SetDefault("ns3::TcpL4Protocol::RecoveryType",
                        TypeIdValue(TypeId::LookupByName(recovery)));
     // Select TCP variant
-    if (transport_prot == "ns3::TcpWestwoodPlus")
-    {
-        // TcpWestwoodPlus is not an actual TypeId name; we need TcpWestwood here
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType", TypeIdValue(TcpWestwood::GetTypeId()));
-        // the default protocol type in ns3::TcpWestwood is WESTWOOD
-        Config::SetDefault("ns3::TcpWestwood::ProtocolType", EnumValue(TcpWestwood::WESTWOODPLUS));
-    }
-    else
-    {
-        TypeId tcpTid;
-        NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(transport_prot, &tcpTid),
-                            "TypeId " << transport_prot << " not found");
-        Config::SetDefault("ns3::TcpL4Protocol::SocketType",
-                           TypeIdValue(TypeId::LookupByName(transport_prot)));
-    }
+    TypeId tcpTid;
+    NS_ABORT_MSG_UNLESS(TypeId::LookupByNameFailSafe(transport_prot, &tcpTid),
+                        "TypeId " << transport_prot << " not found");
+    Config::SetDefault("ns3::TcpL4Protocol::SocketType",
+                       TypeIdValue(TypeId::LookupByName(transport_prot)));
 
     // Create gateways, sources, and sinks
     NodeContainer gateways;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/traffic-control/queue-discs-benchmark.cc ns-3.38/examples/traffic-control/queue-discs-benchmark.cc
--- ns-3.37/examples/traffic-control/queue-discs-benchmark.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/traffic-control/queue-discs-benchmark.cc	2023-03-16 20:54:23.568868400 -0700
@@ -38,13 +38,13 @@
 //
 // The output will consist of a number of ping Rtt such as:
 //
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=111 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=111 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=110 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=111 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=111 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=112 ms
-//    /NodeList/0/ApplicationList/2/$ns3::V4Ping/Rtt=111 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=111 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=111 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=110 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=111 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=111 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=112 ms
+//    /NodeList/0/ApplicationList/2/$ns3::Ping/Rtt=111 ms
 //
 // The files output will consist of a trace file with bytes in queue and of a trace file for limits
 // (when BQL is enabled) both for bottleneck NetDevice on n2, two files with upload and download
@@ -67,9 +67,9 @@
 NS_LOG_COMPONENT_DEFINE("BenchmarkQueueDiscs");
 
 /**
- * Print the queue limitis.
+ * Print the queue limits.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param oldVal Old value.
  * \param newVal New value.
  */
@@ -82,7 +82,7 @@
 /**
  * Print the bytes in the queue.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param oldVal Old value.
  * \param newVal New value.
  */
@@ -96,7 +96,7 @@
  * Sample and print the queue goodput.
  *
  * \param app The Tx app.
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param period The sampling period.
  */
 static void
@@ -116,7 +116,7 @@
  * \param rtt The RTT.
  */
 static void
-PingRtt(std::string context, Time rtt)
+PingRtt(std::string context, uint16_t, Time rtt)
 {
     std::cout << context << "=" << rtt.GetMilliSeconds() << " ms" << std::endl;
 }
@@ -326,10 +326,11 @@
     sourceApps.Add(onOffHelperDown.Install(n3));
 
     // Configure and install ping
-    V4PingHelper ping = V4PingHelper(n3Interface.GetAddress(0));
+    PingHelper ping(n3Interface.GetAddress(0));
+    ping.SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::QUIET));
     ping.Install(n1);
 
-    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::V4Ping/Rtt", MakeCallback(&PingRtt));
+    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::Ping/Rtt", MakeCallback(&PingRtt));
 
     uploadApp.Start(Seconds(0));
     uploadApp.Stop(Seconds(stopTime));
@@ -359,6 +360,8 @@
     FlowMonitorHelper flowHelper;
     flowMonitor = flowHelper.InstallAll();
 
+    accessLink.EnablePcapAll("queue");
+
     Simulator::Stop(Seconds(stopTime));
     Simulator::Run();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/first.py ns-3.38/examples/tutorial/first.py
--- ns-3.37/examples/tutorial/first.py	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/first.py	2023-03-16 20:54:23.568868400 -0700
@@ -49,7 +49,7 @@
 serverApps.Start(ns.core.Seconds(1.0))
 serverApps.Stop(ns.core.Seconds(10.0))
 
-address = ns.addressFromIpv4Address(interfaces.GetAddress(1))
+address = interfaces.GetAddress(1).ConvertTo()
 echoClient = ns.applications.UdpEchoClientHelper(address, 9)
 echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(1))
 echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds(1.0)))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/second.py ns-3.38/examples/tutorial/second.py
--- ns-3.37/examples/tutorial/second.py	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/second.py	2023-03-16 20:54:23.568868400 -0700
@@ -76,7 +76,7 @@
 serverApps.Start(ns.core.Seconds(1.0))
 serverApps.Stop(ns.core.Seconds(10.0))
 
-echoClient = ns.applications.UdpEchoClientHelper(ns.addressFromIpv4Address(csmaInterfaces.GetAddress(nCsma.value)), 9)
+echoClient = ns.applications.UdpEchoClientHelper(csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9)
 echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(1))
 echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds (1.0)))
 echoClient.SetAttribute("PacketSize", ns.core.UintegerValue(1024))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/seventh.cc ns-3.38/examples/tutorial/seventh.cc
--- ns-3.37/examples/tutorial/seventh.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/seventh.cc	2023-03-16 20:54:23.568868400 -0700
@@ -69,7 +69,7 @@
 /**
  * Congestion window change callback
  *
- * \param stream The ouput stream file.
+ * \param stream The output stream file.
  * \param oldCwnd Old congestion window.
  * \param newCwnd New congestion window.
  */
@@ -84,7 +84,7 @@
 /**
  * Rx drop callback
  *
- * \param file The ouput PCAP file.
+ * \param file The output PCAP file.
  * \param p The dropped packet.
  */
 static void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/sixth.cc ns-3.38/examples/tutorial/sixth.cc
--- ns-3.37/examples/tutorial/sixth.cc	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/sixth.cc	2023-03-16 20:54:23.568868400 -0700
@@ -65,7 +65,7 @@
 /**
  * Congestion window change callback
  *
- * \param stream The ouput stream file.
+ * \param stream The output stream file.
  * \param oldCwnd Old congestion window.
  * \param newCwnd New congestion window.
  */
@@ -80,7 +80,7 @@
 /**
  * Rx drop callback
  *
- * \param file The ouput PCAP file.
+ * \param file The output PCAP file.
  * \param p The dropped packet.
  */
 static void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/third.py ns-3.38/examples/tutorial/third.py
--- ns-3.37/examples/tutorial/third.py	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/third.py	2023-03-16 20:54:23.572868300 -0700
@@ -126,7 +126,7 @@
 serverApps.Start(ns.core.Seconds(1.0))
 serverApps.Stop(ns.core.Seconds(10.0))
 
-echoClient = ns.applications.UdpEchoClientHelper(ns.addressFromIpv4Address(csmaInterfaces.GetAddress(nCsma.value)), 9)
+echoClient = ns.applications.UdpEchoClientHelper(csmaInterfaces.GetAddress(nCsma.value).ConvertTo(), 9)
 echoClient.SetAttribute("MaxPackets", ns.core.UintegerValue(1))
 echoClient.SetAttribute("Interval", ns.core.TimeValue(ns.core.Seconds (1.0)))
 echoClient.SetAttribute("PacketSize", ns.core.UintegerValue(1024))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/tutorial/tutorial-app.h ns-3.38/examples/tutorial/tutorial-app.h
--- ns-3.37/examples/tutorial/tutorial-app.h	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/tutorial/tutorial-app.h	2023-03-16 20:54:23.572868300 -0700
@@ -46,7 +46,7 @@
      * \param address The destination address.
      * \param packetSize The packet size to transmit.
      * \param nPackets The number of packets to transmit.
-     * \param dataRate the datarate to use.
+     * \param dataRate the data rate to use.
      */
     void Setup(Ptr<Socket> socket,
                Address address,
@@ -63,14 +63,14 @@
     /// Send a packet.
     void SendPacket();
 
-    Ptr<Socket> m_socket;   //!< The tranmission socket.
+    Ptr<Socket> m_socket;   //!< The transmission socket.
     Address m_peer;         //!< The destination address.
     uint32_t m_packetSize;  //!< The packet size.
-    uint32_t m_nPackets;    //!< The number of pacts to send.
-    DataRate m_dataRate;    //!< The datarate to use.
+    uint32_t m_nPackets;    //!< The number of packets to send.
+    DataRate m_dataRate;    //!< The data rate to use.
     EventId m_sendEvent;    //!< Send event.
     bool m_running;         //!< True if the application is running.
-    uint32_t m_packetsSent; //!< The number of pacts sent.
+    uint32_t m_packetsSent; //!< The number of packets sent.
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/wireless/CMakeLists.txt ns-3.38/examples/wireless/CMakeLists.txt
--- ns-3.37/examples/wireless/CMakeLists.txt	2022-11-01 17:37:24.447394800 -0700
+++ ns-3.38/examples/wireless/CMakeLists.txt	2023-03-16 20:54:23.572868300 -0700
@@ -291,3 +291,10 @@
   SOURCE_FILES wifi-ofdm-eht-validation.cc
   LIBRARIES_TO_LINK ${libwifi}
 )
+
+build_example(
+  NAME wifi-eht-network
+  SOURCE_FILES wifi-eht-network.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
